package com.ruoyi.wgz.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.ruoyi.common.utils.PageUtils;
import com.ruoyi.common.core.page.PagePlus;
import com.ruoyi.common.core.page.TableDataInfo;
import org.springframework.stereotype.Service;
import com.ruoyi.common.core.mybatisplus.core.ServicePlusImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.ruoyi.wgz.bo.WgzQuestionCategoryQueryBo;
import com.ruoyi.wgz.domain.WgzQuestionCategory;
import com.ruoyi.wgz.mapper.WgzQuestionCategoryMapper;
import com.ruoyi.wgz.service.IWgzQuestionCategoryService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 题库_题库类别Service业务层处理
 *
 * @author ruoyi
 * @date 2025-02-17
 */
@Service
public class WgzQuestionCategoryServiceImpl extends ServicePlusImpl<WgzQuestionCategoryMapper, WgzQuestionCategory> implements IWgzQuestionCategoryService {

    @Override
    public WgzQuestionCategory queryById(Long id){
        return getById(id);
    }

    @Override
    public TableDataInfo<WgzQuestionCategory> queryPageList(WgzQuestionCategoryQueryBo bo) {
        Page<WgzQuestionCategory> result = page(PageUtils.buildPage(), buildQueryWrapper(bo));
        return PageUtils.buildDataInfo(result);
    }

    @Override
    public List<WgzQuestionCategory> queryList(WgzQuestionCategoryQueryBo bo) {
        return list(buildQueryWrapper(bo));
    }

    private LambdaQueryWrapper<WgzQuestionCategory> buildQueryWrapper(WgzQuestionCategoryQueryBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<WgzQuestionCategory> lqw = Wrappers.lambdaQuery();
        lqw.like(StrUtil.isNotBlank(bo.getCategoryName()), WgzQuestionCategory::getCategoryName, bo.getCategoryName());
        return lqw;
    }

    @Override
    public Boolean insert(WgzQuestionCategory bo) {
        WgzQuestionCategory add = BeanUtil.toBean(bo, WgzQuestionCategory.class);
        validEntityBeforeSave(add);
        return save(add);
    }

    @Override
    public Boolean update(WgzQuestionCategory bo) {
        WgzQuestionCategory update = BeanUtil.toBean(bo, WgzQuestionCategory.class);
        validEntityBeforeSave(update);
        return updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(WgzQuestionCategory entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return removeByIds(ids);
    }
}
